#!/usr/bin/perl -w
use strict;
#
# zip2html.pl
#
# Useful for generating html content from zip files
# for the purposes of indexing with ht://Dig
#
#
# Configuration:
#
# The only line you should have to change is
# the tmp directory you want to use.
#

# Location of the temp directory you want
# to use. Bear in mind, the ENTIRE contents
# of this directory will be removed at the 
# end of the script.
my $TMP = "/usr2/zipindex";



###################### DO NOT EDIT BELOW THIS LINE! ####################

# Make sure we got a file passed to us
if(!$ARGV[0])
	{
	print "\nUsage:\nzip2html.pl my_file.zip\n\n";
	exit;
	}

# Make sure $TMP is set
if(!$TMP || $TMP eq "")
	{
	print "\nYou MUST define a temp location!\nBe sure that \$TMP is set!\n\n";
	exit;
	}
	
# Grab our package :-)
my $zipfile = $ARGV[0];

# Unzip our package to our temp location
`unzip -d $TMP -o $zipfile`;

# Read the file list into an array
my @files = `zipinfo -1 $zipfile`;

# Initialize our string
my $HTMLOUTPUT = "";

# Loop through our file list from zipinfo
# and pass each document into doc2html
foreach my $file (@files)
	{
	$file =~ s/\n//gi;
	my $fullPath = $TMP."/".$file;
	my $buffer = `/usr/bin/doc2html.pl "$fullPath" 2>&1`;
	# We don't want to see the "unable to convert" string
	if($buffer !~ /UNABLE TO CONVERT/i)
		{
		$HTMLOUTPUT .= $buffer;
		}
	}

# Here we need to get real tags, remove titles, and
# setup just one title at the beginning of the document
# based on the name of the file. This, in turn, will
# be replaced by doc2html.pl, but only if it exists
# in the first place.
$HTMLOUTPUT =~ s/&lt;/</gi;
$HTMLOUTPUT =~ s/&gt;/>/gi;
$HTMLOUTPUT =~ s/<TITLE>.*?<\/TITLE>//gi;	
$HTMLOUTPUT =~ s/<HEAD>/<HEAD>\n<TITLE>$zipfile<\/TITLE>\n/i;

# Print out our results. This is what ht://Dig will index
print $HTMLOUTPUT;

# Make sure we're done and clean up!
sleep 5;
`rm -rf $TMP/*`;
